"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var fs = _interopRequireWildcard(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _child_process = require("child_process");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

var RunCommand = /*#__PURE__*/function () {
  function RunCommand() {
    _classCallCheck(this, RunCommand);
  }

  _createClass(RunCommand, null, [{
    key: "serveCommand",
    value: function serveCommand() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (fs.existsSync(_path["default"].join(process.cwd(), "package.json"))) {
        var cmdParams = ["run", "start"];
        var cmdPath = /^win/.test(process.platform) ? 'npm.cmd' : 'npm';

        var environment = _objectSpread({}, process.env);

        if (Object.keys(options).length != 0 && options.constructor === Object) {
          //cmdParams.push("--"); // pass through
          if (options.hasOwnProperty('port')) {
            environment = _objectSpread(_objectSpread({}, environment), {}, {
              PORT: options.port
            });
          }
        }

        var cmd = (0, _child_process.spawn)(cmdPath, cmdParams, {
          env: _objectSpread({}, environment)
        });
        cmd.stdout.on("data", function (data) {
          console.log("".concat(data));
        });
        cmd.stderr.on("data", function (data) {
          console.log("".concat(data));
        });
        cmd.on('error', function (error) {
          console.log("error: ".concat(error.message));
        });
        cmd.on("close", function (code) {
          console.log("process exited with code ".concat(code));
        });
      } else {
        console.log("Cannot serve from this location");
      }
    }
  }, {
    key: "buildCommand",
    value: function buildCommand() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (fs.existsSync(_path["default"].join(process.cwd(), "package.json"))) {
        var cmdParams = ["run", "build"];
        var cmdPath = /^win/.test(process.platform) ? 'npm.cmd' : 'npm';
        var cmd = (0, _child_process.spawn)(cmdPath, cmdParams);
        cmd.stdout.on("data", function (data) {
          console.log("".concat(data));
        });
        cmd.stderr.on("data", function (data) {
          console.log("".concat(data));
        });
        cmd.on('error', function (error) {
          console.log("error: ".concat(error.message));
        });
        cmd.on("close", function (code) {
          console.log("process exited with code ".concat(code));
        });
      } else {
        console.log("Cannot build from this location");
      }
    }
  }]);

  return RunCommand;
}();

var _default = RunCommand;
exports["default"] = _default;